package com.starcite.marketplace.concurrent;

import java.util.UUID;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.LinkedBlockingQueue;

/**
 * Created by StarCite.
 * User: andy.song
 * Date: Nov 22, 2010
 * Time: 12:05:39 AM
 * To change this template use File | Settings | File Templates.
 */
public class ConcurrentMapTester {

    ConcurrentHashMap<String, Integer> queue = new ConcurrentHashMap<String, Integer>(16000);

    LinkedBlockingQueue<String> queueID = new LinkedBlockingQueue<String>(Integer.MAX_VALUE);

    public class Input extends Thread {
        int i = 0;

        public void run() {
            while (true) {
                long time = System.nanoTime();

                String uuidString = UUID.randomUUID().toString();
                queue.put(uuidString, 0);
                System.out.println("Write cost " + (System.nanoTime() - time) + " nSec");
                try {
                    queueID.put(uuidString);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }



                if (++i == 1000) {
                    break;
                }

            }
        }
    }

    public class Output extends Thread {
        int i = 1000;

        public void run() {
            while (true) {
                String value = queueID.poll();
                //System.out.println(queue.poll());
                if (value != null) {

                    long time = System.nanoTime();
                    int y = queue.get(value);
                    System.out.println("Read cost " + (System.nanoTime() - time) + " nSec");
                    if (--i == 0) {
                        break;
                    }
                }
            }
        }
    }

    public static void main(String[] args) {
        ConcurrentMapTester tester = new ConcurrentMapTester();

        int n = 16;

        for (int i = 0; i < n; ++i) {
            tester.new Input().start();
        }

        for (int i = 0; i < n; ++i) {
            tester.new Output().start();
        }


        //-Xbootclasspath/p:D:/tmp/distribution/lib/concurrent/jsr166.jar

    }

}
